--- fl_vertex.cxx.old	Tue Jun 28 15:53:18 2005
+++ fl_vertex.cxx	Tue Jun 28 16:01:04 2005
@@ -41,12 +41,23 @@
 
 static matrix m = {1, 0, 0, 1, 0, 0};
 
-static matrix stack[10];
+static matrix *stack = NULL;
 static int sptr = 0;
+static int stsize = 0;
 
-void fl_push_matrix() {stack[sptr++] = m;}
+void fl_push_matrix() 
+{
+  if (sptr >= stsize) {
+    stsize += 10;
+    matrix *ns = new matrix[stsize];
+    for (int i = stsize - 11; i >= 0; i--) ns[i] = stack[i]; 
+    delete [] stack;
+    stack = ns;
+  }
+  stack[sptr++] = m;
+}
 
-void fl_pop_matrix() {m = stack[--sptr];}
+void fl_pop_matrix() {if (sptr > 0) m = stack[--sptr];}
 
 void fl_mult_matrix(double a, double b, double c, double d, double x, double y) {
   matrix o;
